/* Autogenerated by mlir-tblgen; don't manually edit */

#ifdef GEN_PASS_DECL
// Generate declarations for all passes.
#define GEN_PASS_DECL_LEGALIZEVECTORSTORAGE
#undef GEN_PASS_DECL
#endif // GEN_PASS_DECL

//===----------------------------------------------------------------------===//
// LegalizeVectorStorage
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_LEGALIZEVECTORSTORAGE
#undef GEN_PASS_DECL_LEGALIZEVECTORSTORAGE
#endif // GEN_PASS_DECL_LEGALIZEVECTORSTORAGE
#ifdef GEN_PASS_DEF_LEGALIZEVECTORSTORAGE
namespace impl {

template <typename DerivedT>
class LegalizeVectorStorageBase : public ::mlir::OperationPass<mlir::func::FuncOp> {
public:
  using Base = LegalizeVectorStorageBase;

  LegalizeVectorStorageBase() : ::mlir::OperationPass<mlir::func::FuncOp>(::mlir::TypeID::get<DerivedT>()) {}
  LegalizeVectorStorageBase(const LegalizeVectorStorageBase &other) : ::mlir::OperationPass<mlir::func::FuncOp>(other) {}
  LegalizeVectorStorageBase& operator=(const LegalizeVectorStorageBase &) = delete;
  LegalizeVectorStorageBase(LegalizeVectorStorageBase &&) = delete;
  LegalizeVectorStorageBase& operator=(LegalizeVectorStorageBase &&) = delete;
  ~LegalizeVectorStorageBase() = default;

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("arm-sve-legalize-vector-storage");
  }
  ::llvm::StringRef getArgument() const override { return "arm-sve-legalize-vector-storage"; }

  ::llvm::StringRef getDescription() const override { return "Ensures stores of SVE vector types will be legal"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LegalizeVectorStorage");
  }
  ::llvm::StringRef getName() const override { return "LegalizeVectorStorage"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<func::FuncDialect>();
    registry.insert<memref::MemRefDialect>();
    registry.insert<vector::VectorDialect>();
    registry.insert<arm_sve::ArmSVEDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LegalizeVectorStorageBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_LEGALIZEVECTORSTORAGE
#endif // GEN_PASS_DEF_LEGALIZEVECTORSTORAGE
#ifdef GEN_PASS_REGISTRATION

//===----------------------------------------------------------------------===//
// LegalizeVectorStorage Registration
//===----------------------------------------------------------------------===//

inline void registerLegalizeVectorStorage() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return mlir::arm_sve::createLegalizeVectorStoragePass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerLegalizeVectorStoragePass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return mlir::arm_sve::createLegalizeVectorStoragePass();
  });
}

//===----------------------------------------------------------------------===//
// ArmSVE Registration
//===----------------------------------------------------------------------===//

inline void registerArmSVEPasses() {
  registerLegalizeVectorStorage();
}
#undef GEN_PASS_REGISTRATION
#endif // GEN_PASS_REGISTRATION
// Deprecated. Please use the new per-pass macros.
#ifdef GEN_PASS_CLASSES

template <typename DerivedT>
class LegalizeVectorStorageBase : public ::mlir::OperationPass<mlir::func::FuncOp> {
public:
  using Base = LegalizeVectorStorageBase;

  LegalizeVectorStorageBase() : ::mlir::OperationPass<mlir::func::FuncOp>(::mlir::TypeID::get<DerivedT>()) {}
  LegalizeVectorStorageBase(const LegalizeVectorStorageBase &other) : ::mlir::OperationPass<mlir::func::FuncOp>(other) {}
  LegalizeVectorStorageBase& operator=(const LegalizeVectorStorageBase &) = delete;
  LegalizeVectorStorageBase(LegalizeVectorStorageBase &&) = delete;
  LegalizeVectorStorageBase& operator=(LegalizeVectorStorageBase &&) = delete;
  ~LegalizeVectorStorageBase() = default;

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("arm-sve-legalize-vector-storage");
  }
  ::llvm::StringRef getArgument() const override { return "arm-sve-legalize-vector-storage"; }

  ::llvm::StringRef getDescription() const override { return "Ensures stores of SVE vector types will be legal"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("LegalizeVectorStorage");
  }
  ::llvm::StringRef getName() const override { return "LegalizeVectorStorage"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<func::FuncDialect>();
    registry.insert<memref::MemRefDialect>();
    registry.insert<vector::VectorDialect>();
    registry.insert<arm_sve::ArmSVEDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(LegalizeVectorStorageBase<DerivedT>)

protected:
};
#undef GEN_PASS_CLASSES
#endif // GEN_PASS_CLASSES
